<?php



function chatbot_settings_fields() {


  if (!get_option('chatbot_beta_settings') ) {
    add_option('chatbot_beta_settings');
  }

  add_settings_section(
    'chatbot_settings_activate',
    'Chatbot Active:',
    '',
    'chatbot-settings',
    ''
  );

  add_settings_section(
    'chatbot_settings_greetings',
    'Chat Bot Greetings',
    '',
    'chatbot-settings',
    ''
  );

  add_settings_section(
    'chatbot_settings_section',
    'Questions',
    'chatbot_description_callback',
    'chatbot-settings',
    array(
      'before_section' => '<div id="question-settings-section">',
      'after_section'  => '</div>'
    )
  );

  add_settings_section(
    'chatbot_settings_suggestions',
    'Suggestions',
    'chatbot_suggestions_callback',
    'chatbot-settings',
    array(
      'before_section' => '<div id="suggestions-settings-section">',
      'after_section'  => '</div>'
    )
  );

  add_settings_section(
    'chatbot_settings_styles',
    'Chat Bot Styling',
    '',
    'chatbot-settings',
    ''
  );

  add_settings_field(
    'chatbot_activate_setting',
    'Activate Chatbot: <br> Use the toggle switch to activate the bot on the front end of your site',
    'chatbot_activate_setting_callback',
    'chatbot-settings',
    'chatbot_settings_activate'
  );

  add_settings_field(
    'chatbot_initial_gretting',
    'Initial Greeting:',
    'chatbot_initial_greeting_callback',
    'chatbot-settings',
    'chatbot_settings_greetings'
  );

  add_settings_field(
    'chatbot_select_name',
    'Bot Name:',
    'chatbot_initial_name_setting_callback',
    'chatbot-settings',
    'chatbot_settings_greetings'
  );

  add_settings_field(
    'chatbot_select_title',
    'Bot Title:',
    'chatbot_initial_title_setting_callback',
    'chatbot-settings',
    'chatbot_settings_greetings'
  );

  add_settings_field(
    'chatbot_select_photo',
    'Bot Photo:',
    'chatbot_media_selector_settings_callback',
    'chatbot-settings',
    'chatbot_settings_greetings'
  );




  add_settings_field(
    'chatbot_question_one',
    'Question One:',
    'chatbot_question_one_callback',
    'chatbot-settings',
    'chatbot_settings_section'
  );

  add_settings_field(
    'chatbot_answer_one',
    'Answer One:',
    'chatbot_answer_one_callback',
    'chatbot-settings',
    'chatbot_settings_section'
  );

  add_settings_field(
    'chatbot_question_two',
    'Question Two:',
    'chatbot_question_two_callback',
    'chatbot-settings',
    'chatbot_settings_section'
  );

  add_settings_field(
    'chatbot_answer_two',
    'Answer Two:',
    'chatbot_answer_two_callback',
    'chatbot-settings',
    'chatbot_settings_section'
  );

  add_settings_field(
    'chatbot_question_three',
    'Question Three:',
    'chatbot_question_three_callback',
    'chatbot-settings',
    'chatbot_settings_section'
  );

  add_settings_field(
    'chatbot_answer_three',
    'Answer Three:',
    'chatbot_answer_three_callback',
    'chatbot-settings',
    'chatbot_settings_section'
  );

  add_settings_field(
    'chatbot_suggestion_one',
    'Suggestion One:',
    'chatbot_suggestion_one_callback',
    'chatbot-settings',
    'chatbot_settings_suggestions'
  );

  add_settings_field(
    'chatbot_color_setting',
    'Icon Color:',
    'chatbot_color_setting_callback',
    'chatbot-settings',
    'chatbot_settings_styles'
  );

  add_settings_field(
    'chatbot_text_color_setting',
    'Icon Text Color:',
    'chatbot_text_color_setting_callback',
    'chatbot-settings',
    'chatbot_settings_styles'
  );

  register_setting (
    'chatbot-settings',
    'chatbot-settings'
  );

};

add_action('admin_init','chatbot_settings_fields');


function chatbot_description_callback() {
 echo 'Add questions here for your chatbot to answer them';
}

function chatbot_suggestions_callback() {
 echo 'Add suggestions here that your bot will fallback to if none of the questions are addressed';
}






function chatbot_activate_setting_callback() {
  $options = get_option('chatbot-settings');
  $bot_active = '';
  if ( isset( $options[ 'bot_active' ] ) ) {
    $bot_active = $options[ 'bot_active' ];
  }

  $html = '<label for="chatbotbeta-bot-active" class="switch">';
  $html .= '<input type=checkbox id=chatbotbeta-bot-active name=chatbot-settings[bot_active] value="1"' . checked( 1, $bot_active, false ) . ' />';
  $html .= '<span class="slider round"></span>';
  $html .= '</label>';


  echo $html;
}


function chatbot_suggestion_one_callback() {
  $options = get_option('chatbot-settings');
  $suggestion_one = '';
  if ( isset( $options[ 'suggestion_one' ] ) ) {
    $suggestion_one = $options[ 'suggestion_one' ];
  }
  echo '<input type=text id=chatbotbeta-suggestion-one name=chatbot-settings[suggestion_one] value="' . $suggestion_one . '" />';
}



function chatbot_question_one_callback() {
  $options = get_option('chatbot-settings');
  $question_one = '';
  if ( isset( $options[ 'question_one' ] ) ) {
    $question_one = $options[ 'question_one' ];
  }
  echo '<input type=text id=chatbotbeta-question-one name=chatbot-settings[question_one] value="' . $question_one . '" />';
}



function chatbot_answer_one_callback() {
  $options = get_option('chatbot-settings');
  $answer_one = '';
  if ( isset( $options[ 'answer_one' ] ) ) {
    $answer_one = $options[ 'answer_one' ];
  }
  echo '<input type=text id=chatbotbeta-answer-one name=chatbot-settings[answer_one] value="' . $answer_one . '" /><br><br><hr>';
}


function chatbot_question_two_callback() {
  $options = get_option('chatbot-settings');
  $question_two = '';
  if ( isset( $options[ 'question_two' ] ) ) {
    $question_two = $options[ 'question_two' ];
  }
  echo '<input type=text id=chatbotbeta-question-two name=chatbot-settings[question_two] value="' . $question_two . '" />';
}



function chatbot_answer_two_callback() {
  $options = get_option('chatbot-settings');
  $answer_two = '';
  if ( isset( $options[ 'answer_two' ] ) ) {
    $answer_two = $options[ 'answer_two' ];
  }
  echo '<input type=text id=chatbotbeta-answer-two name=chatbot-settings[answer_two] value="' . $answer_two . '" /><br><br><hr>';
}


function chatbot_question_three_callback() {
  $options = get_option('chatbot-settings');
  $question_three = '';
  if ( isset( $options[ 'question_three' ] ) ) {
    $question_three = $options[ 'question_three' ];
  }
  echo '<input type=text id=chatbotbeta-question-three name=chatbot-settings[question_three] value="' . $question_three . '" />';
}

function chatbot_answer_three_callback() {
  $options = get_option('chatbot-settings');
  $answer_three = '';
  if ( isset( $options[ 'answer_three' ] ) ) {
    $answer_three = $options[ 'answer_three' ];
  }
  echo '<input type=text id=chatbotbeta-answer-three name=chatbot-settings[answer_three] value="' . $answer_three . '" /><br><br><hr>';
}

function chatbot_color_setting_callback() {
  $options = get_option('chatbot-settings');
  $color_setting = 'blue';
  if ( isset( $options[ 'color_setting' ] ) ) {
    $color_setting = $options[ 'color_setting' ];
  }
  echo '<input type=color id=chatbotbeta-color-set name=chatbot-settings[color_setting] value="' . $color_setting . '" />';
}

function chatbot_text_color_setting_callback() {
  $options = get_option('chatbot-settings');
  $text_color_setting = '';
  if ( isset( $options[ 'text_color_setting' ] ) ) {
    $text_color_setting = $options[ 'text_color_setting' ];
  }
  echo '<input type=color id=chatbotbeta-text-color-set name=chatbot-settings[text_color_setting] value="' . $text_color_setting . '" />';
}

function chatbot_initial_greeting_callback() {
  $options = get_option('chatbot-settings');
  $bot_initial_greeting = '';
  if ( isset( $options[ 'bot_initial_greeting' ] ) ) {
    $bot_initial_greeting = $options[ 'bot_initial_greeting' ];
  }
  echo '<input type=text id=chatbotbeta-initial-greeting-set name=chatbot-settings[bot_initial_greeting] value="' . $bot_initial_greeting . '" /><br><br><hr>';
}

function chatbot_initial_name_setting_callback() {
  $options = get_option('chatbot-settings');
  $bot_name = '';
  if ( isset( $options[ 'bot_name' ] ) ) {
    $bot_name = $options[ 'bot_name' ];
  }
  echo '<input type=text id=chatbotbeta-name-set name=chatbot-settings[bot_name] value="' . $bot_name . '" /><br><br><hr>';
}

function chatbot_initial_title_setting_callback() {
  $options = get_option('chatbot-settings');
  $bot_title = '';
  if ( isset( $options[ 'bot_title' ] ) ) {
    $bot_title = $options[ 'bot_title' ];
  }
  echo '<input type=text id=chatbotbeta-title-set name=chatbot-settings[bot_title] value="' . $bot_title . '" /><br><br><hr>';
}


function chatbot_media_selector_settings_callback() {

  $options = get_option('chatbot-settings');
  $bot_photo = '';
  if ( isset( $options[ 'bot_photo' ] ) ) {
    $bot_photo = $options[ 'bot_photo' ];
  }

  	wp_enqueue_media();

  	?>
  		<div class='image-preview-wrapper'>
  			<img id='image-preview' src='<?php echo wp_get_attachment_url( $bot_photo  ); ?>' height='100'>
  		</div>
  		<input id="upload_image_button" type="button" class="button" value="<?php _e( 'Upload image' ); ?>" />
  		<input type='hidden' name='chatbot-settings[bot_photo]' id='image_attachment_id' value='<?php echo $bot_photo ?>'>

      <?php

}


add_action( 'admin_footer', 'media_selector_print_scripts' );

function media_selector_print_scripts() {

	$my_saved_attachment_post_id = get_option( 'media_selector_attachment_id', 0 );

	?><script type='text/javascript'>

		jQuery( document ).ready( function( $ ) {

			// Uploading files
			var file_frame;
			var wp_media_post_id = wp.media.model.settings.post.id; // Store the old id
			var set_to_post_id = <?php echo $my_saved_attachment_post_id; ?>; // Set this

			jQuery('#upload_image_button').on('click', function( event ){

				event.preventDefault();

				// If the media frame already exists, reopen it.
				if ( file_frame ) {
					// Set the post ID to what we want
					file_frame.uploader.uploader.param( 'post_id', set_to_post_id );
					// Open frame
					file_frame.open();
					return;
				} else {
					// Set the wp.media post id so the uploader grabs the ID we want when initialised
					wp.media.model.settings.post.id = set_to_post_id;
				}

				// Create the media frame.
				file_frame = wp.media.frames.file_frame = wp.media({
					title: 'Select a image to upload',
					button: {
						text: 'Use this image',
					},
					multiple: false	// Set to true to allow multiple files to be selected
				});

				// When an image is selected, run a callback.
				file_frame.on( 'select', function() {
					// We set multiple to false so only get one image from the uploader
					attachment = file_frame.state().get('selection').first().toJSON();

					// Do something with attachment.id and/or attachment.url here
					$( '#image-preview' ).attr( 'src', attachment.url ).css( 'width', 'auto' );
					$( '#image_attachment_id' ).val( attachment.id );

					// Restore the main post ID
					wp.media.model.settings.post.id = wp_media_post_id;
				});

					// Finally, open the modal
					file_frame.open();
			});

			// Restore the main ID when the add media button is pressed
			jQuery( 'a.add_media' ).on( 'click', function() {
				wp.media.model.settings.post.id = wp_media_post_id;
			});
		});

	</script><?php

}
















//
