<?php

/**
 * Plugin Name:       Chat Bot Beta
 * Plugin URI:        https://rapid-rollout.com
 * Description:       Add a customizable chat bot to your wordpress site.
 * Version:           0.1.0
 * Author:            William Damm
 */

if (!defined("ABSPATH")) {
  die("RUN.");
}

include( plugin_dir_path( __FILE__ ) . 'chatbot-settings-fields.php');

function load_styles() {
  wp_enqueue_style('cbb-styles', '/wp-content/plugins/chatbotbeta/style.css' );
}

add_action('wp_enqueue_scripts', 'load_styles');

add_action( 'admin_print_styles', 'load_styles' );

add_action( 'wp_enqueue_scripts', 'my_custom_script_load' );

function my_custom_script_load(){
  wp_enqueue_script( 'my-custom-script', plugin_dir_url( __FILE__ ) . '/js/script.js' );
  wp_register_script( 'my-custom-script', plugin_dir_url( __FILE__ ) . 'js/script.js', array(), '', false );
  wp_localize_script( 'my-custom-script', 'chatBotCustomVars',
  		  	array(
  				'question-one' => get_option('chatbot-settings')['question_one'],
          'answer-one' => get_option('chatbot-settings')['answer_one'],
          'question-two' => get_option('chatbot-settings')['question_two'],
          'answer-two' => get_option('chatbot-settings')['answer_two'],
          'question-three' => get_option('chatbot-settings')['question_three'],
          'answer-three' => get_option('chatbot-settings')['answer_three'],
          'color-style' => get_option('chatbot-settings')['color_setting'],
          'text-color-style' => get_option('chatbot-settings')['text_color_setting'],
          'bot-initial-greeting' => get_option('chatbot-settings')['bot_initial_greeting'],
          'bot-name' => get_option('chatbot-settings')['bot_name'],
          'bot-title' => get_option('chatbot-settings')['bot_title'],
          'bot-photo' => wp_get_attachment_url( get_option('chatbot-settings')['bot_photo']),
          'suggestion-one' => get_option('chatbot-settings')['suggestion_one']
  			)
  		  );

}


function load_Chat_Bot_Markup() {
  if ( get_option('chatbot-settings')['bot_active'] ) {
    require_once('chat-int-template.php');
  }
}

add_action('wp_head', 'load_Chat_Bot_Markup');

function chatbot_settings_page_setup() {
  add_menu_page(
    'chatbot',
    'Chatbot Beta',
    'manage_options',
    'chatbot-settings',
    'chatbot_settings_page_markup',
    'dashicons-format-status',
    20 );
};

add_action('admin_menu', 'chatbot_settings_page_setup');


function chatbot_settings_page_markup() {
  if ( !current_user_can('manage_options') ) {
    return;
  }
  require_once('chat-settings-page-template.php');
};













//
